#include "BusServer.hh"
#include "OrbServerImpl.hh"

using namespace std;
using namespace plpbus;

BusServer::BusServer() {
	orbServer	= new OrbServerImpl();
}

BusServer::~BusServer() {
	cout << "BusServer() destroyed." << endl;
}

int BusServer::init() {
	int		retVal;
	OrbServerImpl	*impl;

	retVal	= 0;
	impl	= (OrbServerImpl *)orbServer;
	impl->init();
	return retVal;
}

int BusServer::launch(const char *server_name) {
	int		retVal;
	OrbServerImpl	*impl;

	impl	= (OrbServerImpl *)orbServer;
	retVal	= impl->launch(server_name);
	return retVal;
}

int BusServer::add_server_listener(IServerListener *listener_param) {
	int		retVal;
	OrbServerImpl	*impl;

	impl	= (OrbServerImpl *)orbServer;
	retVal	= impl->add_server_listener(listener_param);
	return retVal;
}

void BusServer::shutdown() {
	OrbServerImpl	*impl;

	impl	= (OrbServerImpl *)orbServer;
	impl->shutdown();
}
